---
title: MediaRecorder.start()
slug: Web/API/MediaRecorder/start
tags:
  - API
  - Audio
  - Media
  - Media Capture
  - MediaRecorder
  - MediaStream Recording
  - MediaStream Recording API
  - Method
  - NeedsExample
  - Recording Media
  - Reference
  - Video
  - start
---
<div>{{APIRef("MediaStream Recording")}}</div>

<p><span class="seoSummary">The {{domxref("MediaRecorder")}} method <code><strong>start()</strong></code>, which is part of the MediaStream Recording API, begins recording media into one or more {{domxref("Blob")}} objects.</span> You can record the entire duration of the media into a single <code>Blob</code> (or until you call {{domxref("MediaRecorder.requestData", "requestData()")}}), or you can specify the number of milliseconds to record at a time. Then, each time that amount of media has been recorded, an event will be delivered to let you act upon the recorded media, while a new <code>Blob</code> is created to record the next slice of the media</p>

<p>Assuming the <code>MediaRecorder</code>'s {{domxref("MediaRecorder.state", "state")}} is <code>inactive</code>, <code>start()</code> sets the <code>state</code>  to <code>recording</code>, then begins capturing media from the input stream. A <code>Blob</code> is created and the data is collected in it until the time slice period elapses or the source media ends. Each time a <code>Blob</code> is filled up to that point (the timeslice duration or the end-of-media, if no slice duration was provided), a {{event("dataavailable")}} event is sent to the <code>MediaRecorder</code> with the recorded data. If the source is still playing, a new <code>Blob</code> is created and recording continues into that, and so forth.</p>

<p>When the source stream ends, <code>state</code> is set to <code>inactive</code> and data gathering stops. A final {{event("dataavailable")}} event is sent to the <code>MediaRecorder</code>, followed by a {{event("stop")}} event.</p>

<div class="note">
<p><strong>Note</strong>: If the browser is unable to start recording or continue recording, it<em> </em>will raise a {{domxref("DOMError")}} event, followed by a {{domxref("MediaRecorder.dataavailable")}} event containing the <code>Blob</code> it has gathered, followed by the {{domxref("MediaRecorder.stop")}} event.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>mediaRecorder</em>.start(<em>timeslice</em>)</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>timeslice</code> {{optional_inline}}</dt>
 <dd>The number of milliseconds to record into each {{domxref("Blob")}}. If this parameter isn't included, the entire media duration is recorded into a single <code>Blob</code> unless the {{domxref("MediaRecorder.requestData", "requestData()")}} method is called to obtain the <code>Blob</code> and trigger the creation of a new <code>Blob</code> into which the media continues to be recorded.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p><code>undefined</code>.</p>

<h3 id="Exceptions">Exceptions</h3>

<p>Errors that can be detected immediately are thrown as DOM exceptions. All other errors are reported through {{event("error")}} events sent to the <code>MediaRecorder</code> object. You can implement the {{domxref("MediaRecorder.onerror", "onerror")}} event handler to respond to these errors.</p>

<dl>
 <dt><code>InvalidModificationError</code></dt>
 <dd>The number of tracks on the stream being recorded has changed. You can't add or remove tracks while recording media.</dd>
 <dt><code>InvalidStateError</code></dt>
 <dd>The <code>MediaRecorder</code> is not in the <code>inactive</code> state; you can't start recording media if it's already being recorded. See the {{domxref("MediaRecorder.state", "state")}} property.</dd>
 <dt><code>NotSupportedError</code></dt>
 <dd>The media stream you're attempting to record is inactive, or one or more of the stream's tracks is in a format that can't be recorded using the current configuration.</dd>
 <dt><code>SecurityError</code></dt>
 <dd>The {{domxref("MediaStream")}} is configured to disallow recording. This may be the case, for example, with sources obtained using {{domxref("MediaDevices.getUserMedia", "getUserMedia()")}} when the user denies permission to use an input device.  This also happens when a {{domxref("MediaStreamTrack")}} within the stream is marked as {{domxref("MediaStreamTrack.isolated", "isolated")}} due to the {{domxref("MediaStreamConstraints.peerIdentity", "peerIdentity")}} constraint on the source stream. This exception may also be delivered as an {{event("error")}} event if the security options for the source media change after recording begins.</dd>
 <dt><code>UnknownError</code></dt>
 <dd>Something else went wrong during the recording process.</dd>
</dl>

<h2 id="Example">Example</h2>

<pre class="brush: js">...

  record.onclick = function() {
    mediaRecorder.start();
    console.log("recorder started");
  }

...</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName("MediaStream Recording", "#dom-mediarecorder-start", "MediaRecorder.start()")}}</td>
   <td>{{Spec2("MediaStream Recording")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.MediaRecorder.start")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/MediaRecorder_API/Using_the_MediaRecorder_API">Using the MediaRecorder API</a></li>
 <li><a href="https://mdn.github.io/web-dictaphone/">Web Dictaphone</a>: MediaRecorder + getUserMedia + Web Audio API visualization demo, by <a href="https://twitter.com/chrisdavidmills">Chris Mills</a> (<a href="https://github.com/mdn/web-dictaphone/">source on Github</a>.)</li>
 <li><a href="http://simpl.info/mediarecorder/">simpl.info MediaStream Recording demo</a>, by <a href="https://twitter.com/sw12">Sam Dutton</a>.</li>
 <li>{{domxref("MediaDevices.getUserMedia", "getUserMedia()")}}</li>
</ul>
